// PROJECT  :7SegmentEEPROM
// PURPOSE  :Second of three examples highlighting where data can be placed
// COURSE   :ICS3U
// AUTHOR   :C. D'Arcy
// DATE     :2021 04 22
// MCU      :328P/84/85
// STATUS   :Working
// REFERENCE:http://darcy.rsgc.on.ca/ACES/TEI3M/ArduinoCode/TowardsBetterCode.html#memory
#include <EEPROM.h>
#define DURATION 1000
uint8_t digit = 0;
// Seven Segment Lookup Table (LUT) is already in EEPROM

void setup() {
  // declare all pins (except bit 7) of PORTD for output (digital pins 0 through 6)
  for (uint8_t i = 0; i < 7; i++)
    pinMode(i, OUTPUT);
}

void loop() {
  //interpret the specific segment map, displaying the given digit
  uint8_t segmentMap = EEPROM.read(digit);
  for (uint8_t i = 0; i < 7; i++) {
    digitalWrite(i, bitRead(segmentMap, i));
  }
  //pause to admire
  delay(DURATION);
  //cycle through the digits
  digit = (digit + 1) % 10;
}
